﻿/**
Note:
	NeGuiへ移動すべき。
	移動したけど要調整。

History:
	1.00β19:
		新規作成。
*/
module etc.negui.mutex;

debug import std.stdio: wl = writefln;
debug(mutex) void main() {}

import std.contracts;

import win32.windows;

import etc.negui.system.base;

//import nemuxi.system.exception;

///
class MutexException: NeGuiException {
	mixin MixInNeGuiException;
}

/**
History:
	1.100:
		[P] hMutexをHandleRaiiに合わせる。
*/
class Mutex: HandleRaii {
	//protected HANDLE hMutex;
	protected alias Handle hMutex;
	mixin KillResource!("ミューテックス", hMutex, CloseHandle, 0);

	/**
	*/
	enum ACCESSFLAG {
		NONE        = 0,                /// 
		ALL         = MUTEX_ALL_ACCESS, /// ミューテックスオブジェクトで設定できるすべてのアクセスフラグを指定します。
		SYNCHRONIZE = SYNCHRONIZE,      /// Windows NT/2000：すべての「」（待機関数）がミューテックスの所有権を要求するために、また 関数が所有権を解放するために、ミューテックスハンドルを使うことを認めます。
	}
	const protected HandleRaii Duplicate(HANDLE SourceProcessHandle, HANDLE TargetProcessHandle, ACCESSFLAG AccessFlags, bool Inheritance, DUPOPTION DupOption) {
		return Duplicate(SourceProcessHandle, TargetProcessHandle, AccessFlags, Inheritance, DupOption);
	}
	override const protected HandleRaii Duplicate(HANDLE SourceProcessHandle, HANDLE TargetProcessHandle, DWORD AccessFlags, bool Inheritance, DUPOPTION DupOption) {
		return super.Duplicate(SourceProcessHandle, TargetProcessHandle, AccessFlags, Inheritance, DupOption);
	}
	override @property const typeof(this) dup() {
		return Duplicate(
			GetCurrentProcess(), GetCurrentProcess(),
			ACCESSFLAG.ALL, false, DUPOPTION.SAME_ACCESS
		);
	}

	/**
	*/
	this(in Text MutexName) {
		try {
			ERR.initialize;
			auto mutex=CreateMutex(null, 0, MutexName.ptr);
			enforce(ERR.code != ERROR_ALREADY_EXISTS, new MutexException(Text("%s[MutexName = %s]", ERR.toText.text8, MutexName.text8)));
			super(mutex, true);
		} catch(Throwable e) {
			throw new MutexException(Text("Mutex"), e);
		}
	}
}

