﻿/**
ReasMe
<!-- HTML出力前提です -->

<dl>
	<dt>はじめに<dt>
	<dd>
		この文書はNeGui及びそれに付随するものに対するドキュメントです。
		readme.txtな役割をするものだと認識してください。
	</dd>

	<dt>NeGuiとは</dt>
	<dd>
		D用Window APIへ薄皮一枚のラッパー。
		Windows APIを使用したプログラミングの経験のある人が対象。
	</dd>
	<dd>
		もともとはﾈﾑぃ専用GUIクラスだったんだけどどんどんおかしな方向に走り出して今の姿に。
		本来etc.negui.fileみたいなpackageは全く考慮してなかったし。
	</dd>

	<dt>ライセンスとか</dt>
	<dd>
		NYSL。
	</dd>
	<dd>
		バグやら修正やら追加やらがあれば<a href="http://www.usamimi.info/~wokonomono/">サイト</a>かメール(<a href="mailto:wokonomono@gmail.com">wokonomono@gmail.com</a>)に連絡あれば嬉しいです。
	</dd>

	<dt>使用準備</dt>
	<dd>
		<ul>
			<li><a href="http://www.digitalmars.com/">Digital Mars D compiler 2.043</a></li>
			<li><a href="http://www.dsource.org/projects/build/">bud 3.04</a></li>
			<li><a href="http://www.dsource.org/projects/bindings/wiki/WindowsApi">Bindings for the Windows API</a></li>
		</ul>
	</dd>
	<dd>
		Bindings for the Windows APIのwin32\shlobj.dを一部修正する必要があります。
* ----------------------------------------
* module win32.shlobj;
* pragma(lib, "shell32.lib");
*
* // TODO: fix bitfields
* // TODO: CMIC_VALID_SEE_FLAGS
* // SHGetFolderPath in shfolder.dll on W9x, NT4, also in shell32.dll on W2K
*
* import win32.commctrl, win32.ole2, win32.shlguid, win32.shellapi;
* private import win32.prsht, win32.unknwn, win32.w32api, win32.winbase,
*   win32.winnt, win32.winuser, win32.wtypes, win32.objfwd, win32.objidl;
* private import win32.winnetwk; // for NETRESOURCE
*
*
* import win32.oaidl; //@追加
* ...
* ---------------------------------------
		上記の「@追加」の一行を追加してください。
		Windows SDKも忘れずに。<br />
		あと引数がinoutになっている部分をrefに置き換える必要もあります。
		これはコンパイル時に引っ掛かるのでそのときに修正してください。
	</dd>
	<dd>
		budは無くてもいいけどその場合は下記versionをくっつけてください。
		<pre>
dmd @@@.d -version=WindowsXP -version=Unicode -version=IE7
		</pre>
		versionそのものは環境に合わせてください。

		あと.defファイルに
		<pre>
EXETYPE NT
SUBSYSTEM WINDOWS,5.0
		</pre>
		するのも忘れないように。
		値はターゲットに合わせください。

		よくわかんない場合は素直にbud使ってください。
		budを使う場合はetc.negui.bulidで最低限のversionは設定しているので特に何も考えることなく使用できます。
	</dd>
	<dd>
		とまぁ本来ならこれでコンパイル出来るんだろうけど実際問題できません。
		リンカやらスタティックライブラリの知識が皆無なのでなんとも言えませんが取り敢えずの回避策はbud @@@.d -fullすれば動きます。
	</dd>

	<dt>識別子の指針</dt>
	<dd>
		<ul>
			<li>
				※Dのスタイルとは合わないけれども。
				<table>
					<thead>
						<tr>
							<th>識別子</th>
							<th>方針</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td>関数名</td>
							<td>各単語の先頭は大文字。ただし配列への糖衣構文は先頭小文字</td>
						</tr>
						<tr>
							<td>メソッド</td>
							<td>Dの関数の書き方</td>
						</tr>
						<tr>
							<td>戻り値が構造体</td>
							<td>でっかくなければそのまま、でかければref。Textに関しては絶賛迷走中。</td>
						</tr>
						<tr>
							<td>クラス</td>
							<td>各単語の先頭を大文字</td>
						</tr>
						<tr>
							<td>インターフェイス</td>
							<td>多重継承時にクラスなのかインターフェイスなのか明確にするため先頭に「I」、各単語の先頭を大文字</td>
						</tr>
						<tr>
							<td>構造体・共用体</td>
							<td>全部大文字でアンダースコア '_' は使用しない</td>
						</tr>
						<tr>
							<td>構造体・共用体メンバ</td>
							<td>メソッドと同じ</td>
						</tr>
						<tr>
							<td>クラス・構造体・共用体のprivate, protectedメンバ</td>
							<td>各単語の先頭を大文字</td>
						</tr>
						<tr>
							<td>定数・列挙体・列挙型メンバ</td>
							<td>全部大文字</td>
						</tr>
						<tr>
							<td>Windows API - 構造体</td>
							<td>頻繁に使うもので定数とかあるやつはラップ</td>
						</tr>
					</tbody>
				</table>
			</li>
			<li>
				GUIに関係なさげなWindows APIもOK。
			</li>
			<li>
				PhobosでできることはPhobosで。
			</li>
			<li>
				内部でメモリを拡張したりするものはその値を指定可能に。
			</li>
		</ul>
	</dd>
</dl>

History:
	1.100, 2010/05/02:
		[@] 色々変更。
		[@] ﾈﾑぃから分離。
		[@] 独立して公開。
*/
module etc.negui.readme;

debug import std.stdio: wl = writefln;
debug(readme) void main() {}


