﻿/**
History:
	1.010:
		新規作成。
*/
module etc.negui.system.literal;

debug import std.stdio: wl = writefln;
debug(literal) void main() {}

/// バッファサイズ。
enum BUFFER: size_t {
	INITIAL   = 8, /// 初期値。
	INCREMENT = 8, /// インクリメント。

	TEXT = 1024, /// 文字列取得用サイズ。
}
static assert(BUFFER.INITIAL);
static assert(BUFFER.INCREMENT);

/// NeGui バージョン。
enum VER: ushort {
	/**
	メジャーバージョン。

	[1-n]。
	*/
	MAJOR = 1,
	/**
	マイナーバージョン。

	[0-999]。
	*/
	MINOR = 100,
	/**
	特殊。

	<table>
		<thead>
			<tr>
				<th>番号</th>
				<th>意味</th>
			</tr>
		</thead>
		<tbody>
			<tr>
				<th>0</th>
				<td>通常</td>
			</tr>
			<tr>
				<th>1</th>
				<td>開発</td>
			</tr>
		</tbody>
	</table>
	*/
	EX    = 0,
}
static assert(VER.MAJOR);
static assert(0 <= VER.MINOR && VER.MINOR <= 999);



