﻿/**

*/
module etc.negui.window.tooltip.tooltip;

debug import std.stdio: wl = writefln;

debug(tooltip) void main() {}

import win32.windows;
import win32.commctrl;

import etc.negui.system.base;
import etc.negui.negui;
import etc.negui.window.window;

/***/
class ToolTip: Window {
	/**
	History:
		1.022:
			新規作成。
	*/
	protected this(ref NEGUIINFO NeGuiInfo) {
		NeGuiInfo.style     = TTS_ALWAYSTIP;
		NeGuiInfo.className = Text(TOOLTIPS_CLASS);
		super(NeGuiInfo);
	}

	mixin(SMixInItemStyleGetSet("always", q{TTS_ALWAYSTIP}));

	/**
	現在の横幅取得。
	
	Returns:
		現在の横幅。
		設定されていない場合は-1.
	
	History:
		1.022:
			新規作成。
	*/
	size_t width() {
		return send(TTM_GETMAXTIPWIDTH, NONE, NONE);
	}
	/**
	現在の横幅設定。

	Params:
		Width = 設定する横幅。
		        -1にするとたぶん未設定になるんじゃないかなぁ。
	
	Returns:
		以前の横幅。
		設定されていない場合は-1.
	
	History:
		1.022:
			新規作成。
	*/
	size_t width(size_t Width) {
		return send(TTM_SETMAXTIPWIDTH, NONE, Width);
	}
}




